//..........................................//
// PhysX Test                               //
// A8 Engine - PhysX by nVIDIA              //
//                                          //
// Create By : Vahid_PC - VahidPC@GMail.Com //
//..........................................//

#include <default.c>
#include <ackphysx.h>

ENTITY* model;
ENTITY* cam;
VECTOR vSpeed, vAngularSpeed, vForce, vMove;
SOUND* sPong = "tap.wav";

function create_BOM()
{
	pXent_settype(my,PH_RIGID,PH_BOX);
   set(my,SHADOW); 	
}

function create_CAM()
{
	pXent_settype(my,PH_RIGID,PH_SPHERE);
   set(my,SHADOW); 	
}

function Plop()
{
	ent_playsound(model,sPong,100);
	wait(100);
}

function set_shadow()
{
	if(shadow_stencil == 4)
	{
		shadow_stencil = 0;
	}
	else
	{
		shadow_stencil = 4;
	}
}

function control()
{
	while(1)
	{
		if(key_c){model=ent_create("guard.mdl",vector(70,0,0),create_BOM);Plop();}
		if(key_v){model=ent_create("cam.mdl",vector(70,0,0),create_CAM);Plop();}
		vForce.x = -5*(key_force.x + mouse_force.x);	
		vForce.y = 5*(key_force.y + mouse_force.y);
		vForce.z = 0;
		vec_accelerate(vMove,vAngularSpeed,vForce,0.8);
		vec_add(camera.pan,vMove);		
		vForce.x = 6 * (key_w - key_s);		
		vForce.y = 6 * (key_a - key_d);	
		vForce.z = 6 * (key_home - key_end);
		vec_accelerate(vMove,vSpeed,vForce,0.5);
		vec_rotate(vMove,camera.pan);
		vec_add(camera.x,vMove);
		wait(1);
	}
}

function main()
{
	video_mode=9; 
	video_screen=1;
	shadow_stencil = 0; 
	sound_vol = 100;
	d3d_fogcolor1.red = 255;
	d3d_fogcolor1.green = 255;
   d3d_fogcolor1.blue = 255;
   fog_color = 1;
   camera.fog_end=10000;
   warn_level = 1;
	physX_open();
	max_entities = 5000;
	level_load("PhysX.wmb");
	fps_max=60;
	fps_lock=60;
	fps_min=60;
	ph_fps_max_lock = 120;
	model=ent_create("guard.mdl",vector(70,0,0),create_BOM);
	model.event = Plop;
	control();
	on_space = set_shadow;
}